# This is a rough and ugly prototype. It needs some love
import sys
from operator import attrgetter

from PyQt4 import QtCore, QtGui
from qt_browser import Ui_MainWindow

from u1rest import get_files_user


class NodeResourceItem(object):
    def __init__(self, node, parent=None):
        self.parentItem = parent
        self.node = node
        self.childItems = []

    def child(self, row):
        return self.childItems[row]

    def childCount(self):
        return len(self.childItems)

    def columnCount(self):
        return 1

    def data(self, column):
        return self.node

    def parent(self):
        return self.parentItem

    def row(self):
        if self.parentItem:
            return self.parentItem.childItems.index(self)
        return 0

    def load_children(self):
        if not self.childItems and self.node.kind == 'directory':
            self.node.load(with_children=True)
            self.node.children.sort(key=attrgetter('kind'))
            for c in self.node.children:
                self.childItems.append(NodeResourceItem(c, self))


class TreeModel(QtCore.QAbstractItemModel):
    def __init__(self, user, parent=None):
        super(TreeModel, self).__init__(parent)
        root = user.get_node("~/Ubuntu One")
        self.rootItem = NodeResourceItem(root)

    def columnCount(self, parent):
        if parent.isValid():
            return parent.internalPointer().columnCount()
        else:
            return self.rootItem.columnCount()

    def data(self, index, role):
        if not index.isValid():
            return None
        if role == QtCore.Qt.DisplayRole:
            item = index.internalPointer()
            return item.data(index.column()).resource_path.split('/')[-1]

    def flags(self, index):
        if not index.isValid():
            return QtCore.Qt.NoItemFlags
        return QtCore.Qt.ItemIsEnabled | QtCore.Qt.ItemIsSelectable

    def headerData(self, section, orientation, role):
        if orientation == QtCore.Qt.Horizontal and role == QtCore.Qt.DisplayRole:
            return self.rootItem.data(section)
        return None

    def index(self, row, column, parent):
        if not self.hasIndex(row, column, parent):
            return QtCore.QModelIndex()

        if not parent.isValid():
            parentItem = self.rootItem
        else:
            parentItem = parent.internalPointer()

        childItem = parentItem.child(row)
        if childItem:
            return self.createIndex(row, column, childItem)
        else:
            return QtCore.QModelIndex()

    def parent(self, index):
        if not index.isValid():
            return QtCore.QModelIndex()

        childItem = index.internalPointer()
        parentItem = childItem.parent()

        if parentItem == self.rootItem:
            return QtCore.QModelIndex()
        return self.createIndex(parentItem.row(), 0, parentItem)

    def rowCount(self, parent):
        if not parent.isValid():
            parentItem = self.rootItem
        else:
            parentItem = parent.internalPointer()
        return parentItem.childCount()

    def canFetchMore(self, index):
        if not index.isValid():
            parentItem = self.rootItem
        else:
            parentItem = index.internalPointer()
        return (parentItem.node.kind == 'directory' and
                parentItem.node.has_children)

    def fetchMore(self, index):
        if not index.isValid():
            parentItem = self.rootItem
        else:
            parentItem = index.internalPointer()
        parentItem.load_children()

    def hasChildren(self, index):
        if not index.isValid():
            parentItem = self.rootItem
        else:
            parentItem = index.internalPointer()
        n = parentItem.node
        return n.kind == 'directory' and n.has_children


class MainWindow(QtGui.QMainWindow, Ui_MainWindow):
    def __init__(self, parent=None):
        super(MainWindow, self).__init__(parent)
        self.setupUi(self)
        user = get_files_user(use_file_keystore=True)
        self.dirs = TreeModel(user)
        self.treeView.setModel(self.dirs)

if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    frame = MainWindow()
    frame.show()
    app.exec_()
